Index: protocols/yahoo/yahoo2_types.h
===================================================================
--- protocols/yahoo/yahoo2_types.h	(revision ee6cc946dc4ee82cb641df94a6ba101e99253af2)
+++ protocols/yahoo/yahoo2_types.h	(revision 2528cdad90271f80d2ffe0e679ff8258f3e94e4c)
@@ -29,72 +29,173 @@
 #endif
 
-enum yahoo_status {
-	YAHOO_STATUS_DISCONNECTED = -1,
-	YAHOO_STATUS_AVAILABLE = 0,
-	YAHOO_STATUS_BRB,
-	YAHOO_STATUS_BUSY,
-	YAHOO_STATUS_NOTATHOME,
-	YAHOO_STATUS_NOTATDESK,
-	YAHOO_STATUS_NOTINOFFICE,
-	YAHOO_STATUS_ONPHONE,
-	YAHOO_STATUS_ONVACATION,
-	YAHOO_STATUS_OUTTOLUNCH,
-	YAHOO_STATUS_STEPPEDOUT,
-	YAHOO_STATUS_INVISIBLE = 12,
-	YAHOO_STATUS_CUSTOM = 99,
-	YAHOO_STATUS_IDLE = 999,
-	YAHOO_STATUS_WEBLOGIN = 0x5a55aa55,
-	YAHOO_STATUS_OFFLINE = 0x5a55aa56, /* don't ask */
-	YAHOO_STATUS_NOTIFY = 0x16 /* TYPING */
-};
-#define YAHOO_STATUS_GAME	0x2 		/* Games don't fit into the regular status model */
-
-enum yahoo_login_status {
-	YAHOO_LOGIN_OK = 0,
-	YAHOO_LOGIN_LOGOFF = 2,
-	YAHOO_LOGIN_UNAME = 3,
-	YAHOO_LOGIN_PASSWD = 13,
-	YAHOO_LOGIN_LOCK = 14,
-	YAHOO_LOGIN_DUPL = 99,
-	YAHOO_LOGIN_SOCK = -1,
-};
-
-enum ypacket_status {
-	YPACKET_STATUS_DISCONNECTED = -1,
-	YPACKET_STATUS_DEFAULT = 0,
-	YPACKET_STATUS_SERVERACK = 1,
-	YPACKET_STATUS_GAME     = 0x2,
-	YPACKET_STATUS_AWAY     = 0x4,
-	YPACKET_STATUS_CONTINUED = 0x5,
-	YPACKET_STATUS_INVISIBLE = 12,
-	YPACKET_STATUS_NOTIFY = 0x16, /* TYPING */
-	YPACKET_STATUS_WEBLOGIN = 0x5a55aa55,
-	YPACKET_STATUS_OFFLINE = 0x5a55aa56
-};
-
-enum yahoo_error {
-	E_UNKNOWN = -1,
-	E_CONNECTION = -2,
-	E_SYSTEM = -3,
-	E_CUSTOM = 0,
-
-	/* responses from ignore buddy */
-	E_IGNOREDUP = 2,
-	E_IGNORENONE = 3,
-	E_IGNORECONF = 12,
-	
-	/* conference */
-	E_CONFNOTAVAIL = 20
-};
-
-enum yahoo_log_level {
-	YAHOO_LOG_NONE = 0,
-	YAHOO_LOG_FATAL,
-	YAHOO_LOG_ERR,
-	YAHOO_LOG_WARNING,
-	YAHOO_LOG_NOTICE,
-	YAHOO_LOG_INFO,
-	YAHOO_LOG_DEBUG
-};
+	enum yahoo_service {	/* these are easier to see in hex */
+		YAHOO_SERVICE_LOGON = 1,
+		YAHOO_SERVICE_LOGOFF,
+		YAHOO_SERVICE_ISAWAY,
+		YAHOO_SERVICE_ISBACK,
+		YAHOO_SERVICE_IDLE,	/* 5 (placemarker) */
+		YAHOO_SERVICE_MESSAGE,
+		YAHOO_SERVICE_IDACT,
+		YAHOO_SERVICE_IDDEACT,
+		YAHOO_SERVICE_MAILSTAT,
+		YAHOO_SERVICE_USERSTAT,	/* 0xa */
+		YAHOO_SERVICE_NEWMAIL,
+		YAHOO_SERVICE_CHATINVITE,
+		YAHOO_SERVICE_CALENDAR,
+		YAHOO_SERVICE_NEWPERSONALMAIL,
+		YAHOO_SERVICE_NEWCONTACT,
+		YAHOO_SERVICE_ADDIDENT,	/* 0x10 */
+		YAHOO_SERVICE_ADDIGNORE,
+		YAHOO_SERVICE_PING,
+		YAHOO_SERVICE_GOTGROUPRENAME,	/* < 1, 36(old), 37(new) */
+		YAHOO_SERVICE_SYSMESSAGE = 0x14,
+		YAHOO_SERVICE_SKINNAME = 0x15,
+		YAHOO_SERVICE_PASSTHROUGH2 = 0x16,
+		YAHOO_SERVICE_CONFINVITE = 0x18,
+		YAHOO_SERVICE_CONFLOGON,
+		YAHOO_SERVICE_CONFDECLINE,
+		YAHOO_SERVICE_CONFLOGOFF,
+		YAHOO_SERVICE_CONFADDINVITE,
+		YAHOO_SERVICE_CONFMSG,
+		YAHOO_SERVICE_CHATLOGON,
+		YAHOO_SERVICE_CHATLOGOFF,
+		YAHOO_SERVICE_CHATMSG = 0x20,
+		YAHOO_SERVICE_GAMELOGON = 0x28,
+		YAHOO_SERVICE_GAMELOGOFF,
+		YAHOO_SERVICE_GAMEMSG = 0x2a,
+		YAHOO_SERVICE_FILETRANSFER = 0x46,
+		YAHOO_SERVICE_VOICECHAT = 0x4A,
+		YAHOO_SERVICE_NOTIFY,
+		YAHOO_SERVICE_VERIFY,
+		YAHOO_SERVICE_P2PFILEXFER,
+		YAHOO_SERVICE_PEERTOPEER = 0x4F,	/* Checks if P2P possible */
+		YAHOO_SERVICE_WEBCAM,
+		YAHOO_SERVICE_AUTHRESP = 0x54,
+		YAHOO_SERVICE_LIST,
+		YAHOO_SERVICE_AUTH = 0x57,
+		YAHOO_SERVICE_AUTHBUDDY = 0x6d,
+		YAHOO_SERVICE_ADDBUDDY = 0x83,
+		YAHOO_SERVICE_REMBUDDY,
+		YAHOO_SERVICE_IGNORECONTACT,	/* > 1, 7, 13 < 1, 66, 13, 0 */
+		YAHOO_SERVICE_REJECTCONTACT,
+		YAHOO_SERVICE_GROUPRENAME = 0x89,	/* > 1, 65(new), 66(0), 67(old) */
+		YAHOO_SERVICE_Y7_PING = 0x8A,
+		YAHOO_SERVICE_CHATONLINE = 0x96,	/* > 109(id), 1, 6(abcde) < 0,1 */
+		YAHOO_SERVICE_CHATGOTO,
+		YAHOO_SERVICE_CHATJOIN,	/* > 1 104-room 129-1600326591 62-2 */
+		YAHOO_SERVICE_CHATLEAVE,
+		YAHOO_SERVICE_CHATEXIT = 0x9b,
+		YAHOO_SERVICE_CHATADDINVITE = 0x9d,
+		YAHOO_SERVICE_CHATLOGOUT = 0xa0,
+		YAHOO_SERVICE_CHATPING,
+		YAHOO_SERVICE_COMMENT = 0xa8,
+		YAHOO_SERVICE_GAME_INVITE = 0xb7,
+		YAHOO_SERVICE_STEALTH_PERM = 0xb9,
+		YAHOO_SERVICE_STEALTH_SESSION = 0xba,
+		YAHOO_SERVICE_AVATAR = 0xbc,
+		YAHOO_SERVICE_PICTURE_CHECKSUM = 0xbd,
+		YAHOO_SERVICE_PICTURE = 0xbe,
+		YAHOO_SERVICE_PICTURE_UPDATE = 0xc1,
+		YAHOO_SERVICE_PICTURE_UPLOAD = 0xc2,
+		YAHOO_SERVICE_YAB_UPDATE = 0xc4,
+		YAHOO_SERVICE_Y6_VISIBLE_TOGGLE = 0xc5,	/* YMSG13, key 13: 2 = invisible, 1 = visible */
+		YAHOO_SERVICE_Y6_STATUS_UPDATE = 0xc6,	/* YMSG13 */
+		YAHOO_SERVICE_PICTURE_STATUS = 0xc7,	/* YMSG13, key 213: 0 = none, 1 = avatar, 2 = picture */
+		YAHOO_SERVICE_VERIFY_ID_EXISTS = 0xc8,
+		YAHOO_SERVICE_AUDIBLE = 0xd0,
+		YAHOO_SERVICE_Y7_PHOTO_SHARING = 0xd2,
+		YAHOO_SERVICE_Y7_CONTACT_DETAILS = 0xd3,	/* YMSG13 */
+		YAHOO_SERVICE_Y7_CHAT_SESSION = 0xd4,
+		YAHOO_SERVICE_Y7_AUTHORIZATION = 0xd6,	/* YMSG13 */
+		YAHOO_SERVICE_Y7_FILETRANSFER = 0xdc,	/* YMSG13 */
+		YAHOO_SERVICE_Y7_FILETRANSFERINFO,	/* YMSG13 */
+		YAHOO_SERVICE_Y7_FILETRANSFERACCEPT,	/* YMSG13 */
+		YAHOO_SERVICE_Y7_MINGLE = 0xe1,	/* YMSG13 */
+		YAHOO_SERVICE_Y7_CHANGE_GROUP = 0xe7,	/* YMSG13 */
+		YAHOO_SERVICE_MYSTERY = 0xef,	/* Don't know what this is for */
+		YAHOO_SERVICE_Y8_STATUS = 0xf0,	/* YMSG15 */
+		YAHOO_SERVICE_Y8_LIST = 0Xf1,	/* YMSG15 */
+		YAHOO_SERVICE_MESSAGE_CONFIRM = 0xfb,
+		YAHOO_SERVICE_WEBLOGIN = 0x0226,
+		YAHOO_SERVICE_SMS_MSG = 0x02ea
+	};
+
+	enum yahoo_status {
+		YAHOO_STATUS_AVAILABLE = 0,
+		YAHOO_STATUS_BRB,
+		YAHOO_STATUS_BUSY,
+		YAHOO_STATUS_NOTATHOME,
+		YAHOO_STATUS_NOTATDESK,
+		YAHOO_STATUS_NOTINOFFICE,
+		YAHOO_STATUS_ONPHONE,
+		YAHOO_STATUS_ONVACATION,
+		YAHOO_STATUS_OUTTOLUNCH,
+		YAHOO_STATUS_STEPPEDOUT,
+		YAHOO_STATUS_INVISIBLE = 12,
+		YAHOO_STATUS_CUSTOM = 99,
+		YAHOO_STATUS_IDLE = 999,
+		YAHOO_STATUS_OFFLINE = 0x5a55aa56	/* don't ask */
+	};
+
+	enum ypacket_status {
+		YPACKET_STATUS_DISCONNECTED = -1,
+		YPACKET_STATUS_DEFAULT = 0,
+		YPACKET_STATUS_SERVERACK = 1,
+		YPACKET_STATUS_GAME = 0x2,
+		YPACKET_STATUS_AWAY = 0x4,
+		YPACKET_STATUS_CONTINUED = 0x5,
+		YPACKET_STATUS_INVISIBLE = 12,
+		YPACKET_STATUS_NOTIFY = 0x16,	/* TYPING */
+		YPACKET_STATUS_WEBLOGIN = 0x5a55aa55,
+		YPACKET_STATUS_OFFLINE = 0x5a55aa56
+	};
+
+#define YAHOO_STATUS_GAME	0x2	/* Games don't fit into the regular status model */
+
+	enum yahoo_login_status {
+		YAHOO_LOGIN_OK = 0,
+		YAHOO_LOGIN_LOGOFF = 1,
+		YAHOO_LOGIN_UNAME = 3,
+		YAHOO_LOGIN_PASSWD = 13,
+		YAHOO_LOGIN_LOCK = 14,
+		YAHOO_LOGIN_DUPL = 99,
+		YAHOO_LOGIN_SOCK = -1,
+		YAHOO_LOGIN_UNKNOWN = 999
+	};
+
+	enum yahoo_error {
+		E_UNKNOWN = -1,
+		E_CONNECTION = -2,
+		E_SYSTEM = -3,
+		E_CUSTOM = 0,
+
+		/* responses from ignore buddy */
+		E_IGNOREDUP = 2,
+		E_IGNORENONE = 3,
+		E_IGNORECONF = 12,
+
+		/* conference */
+		E_CONFNOTAVAIL = 20
+	};
+
+	enum yahoo_log_level {
+		YAHOO_LOG_NONE = 0,
+		YAHOO_LOG_FATAL,
+		YAHOO_LOG_ERR,
+		YAHOO_LOG_WARNING,
+		YAHOO_LOG_NOTICE,
+		YAHOO_LOG_INFO,
+		YAHOO_LOG_DEBUG
+	};
+
+	enum yahoo_file_transfer {
+		YAHOO_FILE_TRANSFER_INIT = 1,
+		YAHOO_FILE_TRANSFER_ACCEPT = 3,
+		YAHOO_FILE_TRANSFER_REJECT = 4,
+		YAHOO_FILE_TRANSFER_DONE = 5,
+		YAHOO_FILE_TRANSFER_RELAY,
+		YAHOO_FILE_TRANSFER_FAILED,
+		YAHOO_FILE_TRANSFER_UNKNOWN
+	};
 
 #define YAHOO_PROTO_VER 0x0010
@@ -121,170 +222,175 @@
 #define YAHOO_STYLE_URLOFF "\033[xlm"
 
-enum yahoo_connection_type {
-	YAHOO_CONNECTION_PAGER=0,
-	YAHOO_CONNECTION_FT,
-	YAHOO_CONNECTION_YAB,
-	YAHOO_CONNECTION_WEBCAM_MASTER,
-	YAHOO_CONNECTION_WEBCAM,
-	YAHOO_CONNECTION_CHATCAT,
-	YAHOO_CONNECTION_SEARCH,
-	YAHOO_CONNECTION_AUTH,
-};
-
-enum yahoo_webcam_direction_type {
-        YAHOO_WEBCAM_DOWNLOAD=0,
-        YAHOO_WEBCAM_UPLOAD
-};
-
-enum yahoo_stealth_visibility_type {
-	YAHOO_STEALTH_DEFAULT = 0,
-  	YAHOO_STEALTH_ONLINE,
-  	YAHOO_STEALTH_PERM_OFFLINE
-};
+	enum yahoo_connection_type {
+		YAHOO_CONNECTION_PAGER = 0,
+		YAHOO_CONNECTION_FT,
+		YAHOO_CONNECTION_YAB,
+		YAHOO_CONNECTION_WEBCAM_MASTER,
+		YAHOO_CONNECTION_WEBCAM,
+		YAHOO_CONNECTION_CHATCAT,
+		YAHOO_CONNECTION_SEARCH,
+		YAHOO_CONNECTION_AUTH
+	};
+
+	enum yahoo_webcam_direction_type {
+		YAHOO_WEBCAM_DOWNLOAD = 0,
+		YAHOO_WEBCAM_UPLOAD
+	};
+
+	enum yahoo_stealth_visibility_type {
+		YAHOO_STEALTH_DEFAULT = 0,
+		YAHOO_STEALTH_ONLINE,
+		YAHOO_STEALTH_PERM_OFFLINE
+	};
 
 /* chat member attribs */
 #define YAHOO_CHAT_MALE 0x8000
 #define YAHOO_CHAT_FEMALE 0x10000
+#define YAHOO_CHAT_FEMALE 0x10000
 #define YAHOO_CHAT_DUNNO 0x400
 #define YAHOO_CHAT_WEBCAM 0x10
 
-enum yahoo_webcam_conn_type { Y_WCM_DIALUP, Y_WCM_DSL, Y_WCM_T1 };
-
-struct yahoo_webcam {
-	int direction;     /* Uploading or downloading */
-	int conn_type;     /* 0=Dialup, 1=DSL/Cable, 2=T1/Lan */
-
-	char *user;        /* user we are viewing */
-	char *server;      /* webcam server to connect to */
-	int   port;        /* webcam port to connect on */
-	char *key;         /* key to connect to the server with */
-	char *description; /* webcam description */
-	char *my_ip;       /* own ip number */
-};
-
-struct yahoo_webcam_data {
-	unsigned int data_size;
-	unsigned int to_read;
-	unsigned int timestamp;
-	unsigned char packet_type;
-};
-
-struct yahoo_data {
-	char  *user;
-	char  *password;
-
-	char  *cookie_y;
-	char  *cookie_t;
-	char  *cookie_c;
-	char  *login_cookie;
-
-	YList *buddies;
-	YList *ignore;
-	YList *identities;
-	char  *login_id;
-
-	int   current_status;
-	int   initial_status;
-	int   logged_in;
-
-	int   session_id;
-
-	int   client_id;
-
-	char  *rawbuddylist;
-	char  *ignorelist;
-
-	void  *server_settings;
-	
-	struct yahoo_process_status_entry *half_user;
-};
-
-struct yab {
-	char *id;
-	char *fname;
-	char *lname;
-	char *nname;
-	char *email;
-	char *hphone;
-	char *wphone;
-	char *mphone;
-	int  dbid;
-};
-
-struct yahoo_buddy {
-	char *group;
-	char *id;
-	char *real_name;
-	struct yab *yab_entry;
-};
-
-enum yahoo_search_type {
-	YAHOO_SEARCH_KEYWORD = 0,
-	YAHOO_SEARCH_YID,
-	YAHOO_SEARCH_NAME
-};
-
-enum yahoo_search_gender {
-	YAHOO_GENDER_NONE = 0,
-	YAHOO_GENDER_MALE,
-	YAHOO_GENDER_FEMALE
-};
-
-enum yahoo_search_agerange {
-	YAHOO_AGERANGE_NONE = 0
-};
-
-struct yahoo_found_contact {
-	char *id;
-	char *gender;
-	char *location;
-	int age;
-	int online;
-};
+	enum yahoo_webcam_conn_type { Y_WCM_DIALUP, Y_WCM_DSL, Y_WCM_T1 };
+
+	struct yahoo_webcam {
+		int direction;	/* Uploading or downloading */
+		int conn_type;	/* 0=Dialup, 1=DSL/Cable, 2=T1/Lan */
+
+		char *user;	/* user we are viewing */
+		char *server;	/* webcam server to connect to */
+		int port;	/* webcam port to connect on */
+		char *key;	/* key to connect to the server with */
+		char *description;	/* webcam description */
+		char *my_ip;	/* own ip number */
+	};
+
+	struct yahoo_webcam_data {
+		unsigned int data_size;
+		unsigned int to_read;
+		unsigned int timestamp;
+		unsigned char packet_type;
+	};
+
+	struct yahoo_data {
+		char *user;
+		char *password;
+
+		char *cookie_y;
+		char *cookie_t;
+		char *cookie_c;
+		char *cookie_b;
+		char *login_cookie;
+		char *crumb;
+		char *seed;
+
+		YList *buddies;
+		YList *ignore;
+		YList *identities;
+		char *login_id;
+
+		int current_status;
+		int initial_status;
+		int logged_in;
+
+		int session_id;
+
+		int client_id;
+
+		char *rawbuddylist;
+		char *ignorelist;
+
+		void *server_settings;
+
+		struct yahoo_process_status_entry *half_user;
+	};
+
+	struct yab {
+		int yid;
+		char *id;
+		char *fname;
+		char *lname;
+		char *nname;
+		char *email;
+		char *hphone;
+		char *wphone;
+		char *mphone;
+		int dbid;
+	};
+
+	struct yahoo_buddy {
+		char *group;
+		char *id;
+		char *real_name;
+		struct yab *yab_entry;
+	};
+
+	enum yahoo_search_type {
+		YAHOO_SEARCH_KEYWORD = 0,
+		YAHOO_SEARCH_YID,
+		YAHOO_SEARCH_NAME
+	};
+
+	enum yahoo_search_gender {
+		YAHOO_GENDER_NONE = 0,
+		YAHOO_GENDER_MALE,
+		YAHOO_GENDER_FEMALE
+	};
+
+	enum yahoo_search_agerange {
+		YAHOO_AGERANGE_NONE = 0
+	};
+
+	struct yahoo_found_contact {
+		char *id;
+		char *gender;
+		char *location;
+		int age;
+		int online;
+	};
 
 /*
  * Function pointer to be passed to http get/post and send file
  */
-typedef void (*yahoo_get_fd_callback)(int id, int fd, int error, void *data);
+	typedef void (*yahoo_get_fd_callback) (int id, void *fd, int error,
+		void *data);
 
 /*
  * Function pointer to be passed to yahoo_get_url_handle
  */
-typedef void (*yahoo_get_url_handle_callback)(int id, int fd, int error,
-		const char *filename, unsigned long size, void *data);
-
-
-struct yahoo_chat_member {
-	char *id;
-	int  age;
-	int  attribs;
-	char *alias;
-	char *location;
-};
-
-struct yahoo_process_status_entry {
-	char *name;	/* 7      name */
-	int state;	/* 10     state */
-	int flags;	/* 13     flags, bit 0 = pager, bit 1 = chat, bit 2 = game */
-	int mobile;	/* 60     mobile */
-	char *msg;	/* 19     custom status message */
-	int away;	/* 47     away (or invisible) */
-	int buddy_session; /* 11  state */
-	int f17;	/* 17     in chat? then what about flags? */
-	int idle;	/* 137    seconds idle */
-	int f138;	/* 138    state */
-	char *f184;	/* 184    state */
-	int f192;	/* 192    state */
-	int f10001;	/* 10001  state */
-	int f10002;	/* 10002  state */
-	int f198;	/* 198    state */
-	char *f197;	/* 197    state */
-	char *f205;	/* 205    state */
-	int f213;	/* 213    state */
-};
+	typedef void (*yahoo_get_url_handle_callback) (int id, void *fd,
+		int error, const char *filename, unsigned long size,
+		void *data);
+
+	struct yahoo_chat_member {
+		char *id;
+		int age;
+		int attribs;
+		char *alias;
+		char *location;
+	};
+
+	struct yahoo_process_status_entry { 
+		char *name;     /* 7      name */ 
+		int state;      /* 10     state */ 
+		int flags;      /* 13     flags, bit 0 = pager, bit 1 = chat, bit 2 = game */ 
+		int mobile;     /* 60     mobile */ 
+		char *msg;      /* 19     custom status message */ 
+		int away;       /* 47     away (or invisible) */ 
+		int buddy_session; /* 11  state */ 
+		int f17;        /* 17     in chat? then what about flags? */ 
+		int idle;       /* 137    seconds idle */ 
+		int f138;       /* 138    state */ 
+		char *f184;     /* 184    state */ 
+		int f192;       /* 192    state */ 
+		int f10001;     /* 10001  state */ 
+		int f10002;     /* 10002  state */ 
+		int f198;       /* 198    state */ 
+		char *f197;     /* 197    state */ 
+		char *f205;     /* 205    state */ 
+		int f213;       /* 213    state */ 
+	};
 
 #ifdef __cplusplus
 }
 #endif
-
 #endif
Index: protocols/yahoo/yahoo_fn.h
===================================================================
--- protocols/yahoo/yahoo_fn.h	(revision ee6cc946dc4ee82cb641df94a6ba101e99253af2)
+++ protocols/yahoo/yahoo_fn.h	(revision 2528cdad90271f80d2ffe0e679ff8258f3e94e4c)
@@ -19,15 +19,14 @@
  */
 
-#define IDENT  1 /* identify function */
-#define XOR    2 /* xor with arg1 */
-#define MULADD 3 /* multipy by arg1 then add arg2 */
-#define LOOKUP 4 /* lookup each byte in the table pointed to by arg1 */
-#define BITFLD 5 /* reorder bits according to table pointed to by arg1 */
+#define IDENT  1		/* identify function */
+#define XOR    2		/* xor with arg1 */
+#define MULADD 3		/* multipy by arg1 then add arg2 */
+#define LOOKUP 4		/* lookup each byte in the table pointed to by arg1 */
+#define BITFLD 5		/* reorder bits according to table pointed to by arg1 */
 
-struct yahoo_fn
-{
-	int type; 
+struct yahoo_fn {
+	int type;
 	long arg1, arg2;
 };
 
-int yahoo_xfrm( int table, int depth, int seed );
+int yahoo_xfrm(int table, int depth, int seed);
Index: protocols/yahoo/yahoo_httplib.c
===================================================================
--- protocols/yahoo/yahoo_httplib.c	(revision ee6cc946dc4ee82cb641df94a6ba101e99253af2)
+++ protocols/yahoo/yahoo_httplib.c	(revision 2528cdad90271f80d2ffe0e679ff8258f3e94e4c)
@@ -30,5 +30,5 @@
 #  define strrchr rindex
 # endif
-char *strchr (), *strrchr ();
+char *strchr(), *strrchr();
 # if !HAVE_MEMCPY
 #  define memcpy(d, s, n) bcopy ((s), (d), (n))
@@ -36,5 +36,4 @@
 # endif
 #endif
-
 
 #include <errno.h>
@@ -63,5 +62,5 @@
 extern enum yahoo_log_level log_level;
 
-int yahoo_tcp_readline(char *ptr, int maxlen, int fd)
+int yahoo_tcp_readline(char *ptr, int maxlen, void *fd)
 {
 	int n, rc;
@@ -71,9 +70,9 @@
 
 		do {
-			rc = read(fd, &c, 1);
-		} while(rc == -1 && (errno == EINTR || errno == EAGAIN)); /* this is bad - it should be done asynchronously */
+			rc = YAHOO_CALLBACK(ext_yahoo_read) (fd, &c, 1);
+		} while (rc == -1 && (errno == EINTR || errno == EAGAIN));	/* this is bad - it should be done asynchronously */
 
 		if (rc == 1) {
-			if(c == '\r')			/* get rid of \r */
+			if (c == '\r')	/* get rid of \r */
 				continue;
 			*ptr = c;
@@ -83,7 +82,7 @@
 		} else if (rc == 0) {
 			if (n == 1)
-				return (0);		/* EOF, no data */
+				return (0);	/* EOF, no data */
 			else
-				break;			/* EOF, w/ data */
+				break;	/* EOF, w/ data */
 		} else {
 			return -1;
@@ -96,10 +95,10 @@
 
 static int url_to_host_port_path(const char *url,
-		char *host, int *port, char *path)
-{
-	char *urlcopy=NULL;
-	char *slash=NULL;
-	char *colon=NULL;
-	
+	char *host, int *port, char *path, int *ssl)
+{
+	char *urlcopy = NULL;
+	char *slash = NULL;
+	char *colon = NULL;
+
 	/*
 	 * http://hostname
@@ -111,8 +110,12 @@
 	 * http://hostname:port/path
 	 * http://hostname:port/path:foo
+	 * and https:// variants of the above
 	 */
 
-	if(strstr(url, "http://") == url) {
-		urlcopy = strdup(url+7);
+	if (strstr(url, "http://") == url) {
+		urlcopy = strdup(url + 7);
+	} else if (strstr(url, "https://") == url) {
+		urlcopy = strdup(url + 8);
+		*ssl = 1;
 	} else {
 		WARNING(("Weird url - unknown protocol: %s", url));
@@ -123,12 +126,15 @@
 	colon = strchr(urlcopy, ':');
 
-	if(!colon || (slash && slash < colon)) {
-		*port = 80;
+	if (!colon || (slash && slash < colon)) {
+		if (*ssl)
+			*port = 443;
+		else
+			*port = 80;
 	} else {
 		*colon = 0;
-		*port = atoi(colon+1);
-	}
-
-	if(!slash) {
+		*port = atoi(colon + 1);
+	}
+
+	if (!slash) {
 		strcpy(path, "/");
 	} else {
@@ -138,5 +144,5 @@
 
 	strcpy(host, urlcopy);
-	
+
 	FREE(urlcopy);
 
@@ -146,31 +152,31 @@
 static int isurlchar(unsigned char c)
 {
-	return (isalnum(c) || '-' == c || '_' == c);
+	return (isalnum(c));
 }
 
 char *yahoo_urlencode(const char *instr)
 {
-	int ipos=0, bpos=0;
+	int ipos = 0, bpos = 0;
 	char *str = NULL;
 	int len = strlen(instr);
 
-	if(!(str = y_new(char, 3*len + 1) ))
-		return "";
-
-	while(instr[ipos]) {
-		while(isurlchar(instr[ipos]))
+	if (!(str = y_new(char, 3 *len + 1)))
+		 return "";
+
+	while (instr[ipos]) {
+		while (isurlchar(instr[ipos]))
 			str[bpos++] = instr[ipos++];
-		if(!instr[ipos])
+		if (!instr[ipos])
 			break;
-		
-		snprintf(&str[bpos], 4, "%%%.2x", instr[ipos]);
-		bpos+=3;
+
+		snprintf(&str[bpos], 4, "%%%02x", instr[ipos] & 0xff);
+		bpos += 3;
 		ipos++;
 	}
-	str[bpos]='\0';
+	str[bpos] = '\0';
 
 	/* free extra alloc'ed mem. */
 	len = strlen(str);
-	str = y_renew(char, str, len+1);
+	str = y_renew(char, str, len + 1);
 
 	return (str);
@@ -179,27 +185,27 @@
 char *yahoo_urldecode(const char *instr)
 {
-	int ipos=0, bpos=0;
+	int ipos = 0, bpos = 0;
 	char *str = NULL;
-	char entity[3]={0,0,0};
+	char entity[3] = { 0, 0, 0 };
 	unsigned dec;
 	int len = strlen(instr);
 
-	if(!(str = y_new(char, len+1) ))
-		return "";
-
-	while(instr[ipos]) {
-		while(instr[ipos] && instr[ipos]!='%')
-			if(instr[ipos]=='+') {
-				str[bpos++]=' ';
+	if (!(str = y_new(char, len + 1)))
+		 return "";
+
+	while (instr[ipos]) {
+		while (instr[ipos] && instr[ipos] != '%')
+			if (instr[ipos] == '+') {
+				str[bpos++] = ' ';
 				ipos++;
 			} else
 				str[bpos++] = instr[ipos++];
-		if(!instr[ipos])
+		if (!instr[ipos])
 			break;
-		
-		if(instr[ipos+1] && instr[ipos+2]) {
+
+		if (instr[ipos + 1] && instr[ipos + 2]) {
 			ipos++;
-			entity[0]=instr[ipos++];
-			entity[1]=instr[ipos++];
+			entity[0] = instr[ipos++];
+			entity[1] = instr[ipos++];
 			sscanf(entity, "%2x", &dec);
 			str[bpos++] = (char)dec;
@@ -208,9 +214,9 @@
 		}
 	}
-	str[bpos]='\0';
+	str[bpos] = '\0';
 
 	/* free extra alloc'ed mem. */
 	len = strlen(str);
-	str = y_renew(char, str, len+1);
+	str = y_renew(char, str, len + 1);
 
 	return (str);
@@ -219,12 +225,12 @@
 char *yahoo_xmldecode(const char *instr)
 {
-	int ipos=0, bpos=0, epos=0;
+	int ipos = 0, bpos = 0, epos = 0;
 	char *str = NULL;
-	char entity[4]={0,0,0,0};
-	char *entitymap[5][2]={
-		{"amp;",  "&"}, 
+	char entity[4] = { 0, 0, 0, 0 };
+	char *entitymap[5][2] = {
+		{"amp;", "&"},
 		{"quot;", "\""},
-		{"lt;",   "<"}, 
-		{"gt;",   "<"}, 
+		{"lt;", "<"},
+		{"gt;", "<"},
 		{"nbsp;", " "}
 	};
@@ -232,23 +238,23 @@
 	int len = strlen(instr);
 
-	if(!(str = y_new(char, len+1) ))
-		return "";
-
-	while(instr[ipos]) {
-		while(instr[ipos] && instr[ipos]!='&')
-			if(instr[ipos]=='+') {
-				str[bpos++]=' ';
+	if (!(str = y_new(char, len + 1)))
+		 return "";
+
+	while (instr[ipos]) {
+		while (instr[ipos] && instr[ipos] != '&')
+			if (instr[ipos] == '+') {
+				str[bpos++] = ' ';
 				ipos++;
 			} else
 				str[bpos++] = instr[ipos++];
-		if(!instr[ipos] || !instr[ipos+1])
+		if (!instr[ipos] || !instr[ipos + 1])
 			break;
 		ipos++;
 
-		if(instr[ipos] == '#') {
+		if (instr[ipos] == '#') {
 			ipos++;
-			epos=0;
-			while(instr[ipos] != ';')
-				entity[epos++]=instr[ipos++];
+			epos = 0;
+			while (instr[ipos] != ';')
+				entity[epos++] = instr[ipos++];
 			sscanf(entity, "%u", &dec);
 			str[bpos++] = (char)dec;
@@ -256,8 +262,8 @@
 		} else {
 			int i;
-			for (i=0; i<5; i++) 
-				if(!strncmp(instr+ipos, entitymap[i][0], 
-					       strlen(entitymap[i][0]))) {
-				       	str[bpos++] = entitymap[i][1][0];
+			for (i = 0; i < 5; i++)
+				if (!strncmp(instr + ipos, entitymap[i][0],
+						strlen(entitymap[i][0]))) {
+					str[bpos++] = entitymap[i][1][0];
 					ipos += strlen(entitymap[i][0]);
 					break;
@@ -265,14 +271,14 @@
 		}
 	}
-	str[bpos]='\0';
+	str[bpos] = '\0';
 
 	/* free extra alloc'ed mem. */
 	len = strlen(str);
-	str = y_renew(char, str, len+1);
+	str = y_renew(char, str, len + 1);
 
 	return (str);
 }
 
-typedef void (*http_connected)(int id, int fd, int error);
+typedef void (*http_connected) (int id, void *fd, int error);
 
 struct callback_data {
@@ -283,28 +289,30 @@
 };
 
-static void connect_complete(int fd, int error, void *data)
+static void connect_complete(void *fd, int error, void *data)
 {
 	struct callback_data *ccd = data;
-	if(error == 0 && fd > 0)
-		write(fd, ccd->request, strlen(ccd->request));
-	FREE(ccd->request);
+	if (error == 0)
+		YAHOO_CALLBACK(ext_yahoo_write) (fd, ccd->request,
+			strlen(ccd->request));
+	free(ccd->request);
 	ccd->callback(ccd->id, fd, error, ccd->user_data);
 	FREE(ccd);
 }
 
-static void yahoo_send_http_request(int id, char *host, int port, char *request, 
-		yahoo_get_fd_callback callback, void *data)
-{
-	struct callback_data *ccd=y_new0(struct callback_data, 1);
+static void yahoo_send_http_request(int id, char *host, int port, char *request,
+	yahoo_get_fd_callback callback, void *data, int use_ssl)
+{
+	struct callback_data *ccd = y_new0(struct callback_data, 1);
 	ccd->callback = callback;
 	ccd->id = id;
 	ccd->request = strdup(request);
 	ccd->user_data = data;
-	
-	YAHOO_CALLBACK(ext_yahoo_connect_async)(id, host, port, connect_complete, ccd);
-}
-
-void yahoo_http_post(int id, const char *url, const char *cookies, long content_length,
-		yahoo_get_fd_callback callback, void *data)
+
+	YAHOO_CALLBACK(ext_yahoo_connect_async) (id, host, port,
+		connect_complete, ccd, use_ssl);
+}
+
+void yahoo_http_post(int id, const char *url, const char *cookies,
+	long content_length, yahoo_get_fd_callback callback, void *data)
 {
 	char host[255];
@@ -312,120 +320,85 @@
 	char path[255];
 	char buff[1024];
-	
-	if(!url_to_host_port_path(url, host, &port, path))
+	int ssl = 0;
+
+	if (!url_to_host_port_path(url, host, &port, path, &ssl))
 		return;
 
-	snprintf(buff, sizeof(buff), 
-			"POST %s HTTP/1.0\r\n"
-			"Content-length: %ld\r\n"
-			"User-Agent: Mozilla/4.5 [en] (" PACKAGE "/" VERSION ")\r\n"
-			"Host: %s:%d\r\n"
-			"Cookie: %s\r\n"
-			"\r\n",
-			path, content_length, 
-			host, port,
-			cookies);
-
-	yahoo_send_http_request(id, host, port, buff, callback, data);
-}
-
-void yahoo_http_get(int id, const char *url, const char *cookies,
-		yahoo_get_fd_callback callback, void *data)
+	/* thanks to kopete dumpcap */
+	snprintf(buff, sizeof(buff),
+		"POST %s HTTP/1.1\r\n"
+		"Cookie: %s\r\n"
+		"User-Agent: Mozilla/5.0\r\n"
+		"Host: %s\r\n"
+		"Content-Length: %ld\r\n"
+		"Cache-Control: no-cache\r\n"
+		"\r\n", path, cookies, host, content_length);
+
+	yahoo_send_http_request(id, host, port, buff, callback, data, ssl);
+}
+
+void yahoo_http_get(int id, const char *url, const char *cookies, int http11,
+	int keepalive, yahoo_get_fd_callback callback, void *data)
 {
 	char host[255];
 	int port = 80;
 	char path[255];
-	char buff[1024];
-	
-	if(!url_to_host_port_path(url, host, &port, path))
+	char buff[2048];
+	char cookiebuff[1024];
+	int ssl = 0;
+
+	if (!url_to_host_port_path(url, host, &port, path, &ssl))
 		return;
 
-	snprintf(buff, sizeof(buff), 
-			"GET %s HTTP/1.0\r\n"
-			"Host: %s:%d\r\n"
-			"User-Agent: Mozilla/4.5 [en] (" PACKAGE "/" VERSION ")\r\n"
-			"Cookie: %s\r\n"
-			"\r\n",
-			path, host, port, cookies);
-
-	yahoo_send_http_request(id, host, port, buff, callback, data);
-}
-
-struct url_data {
-	yahoo_get_url_handle_callback callback;
-	void *user_data;
-};
-
-static void yahoo_got_url_fd(int id, int fd, int error, void *data)
-{
-	char *tmp=NULL;
-	char buff[1024];
-	unsigned long filesize=0;
-	char *filename=NULL;
-	int n;
-
-	struct url_data *ud = data;
-
-	if(error || fd < 0) {
-		ud->callback(id, fd, error, filename, filesize, ud->user_data);
-		FREE(ud);
+	/* Allow cases when we don't need to send a cookie */
+	if (cookies)
+		snprintf(cookiebuff, sizeof(cookiebuff), "Cookie: %s\r\n",
+			cookies);
+	else
+		cookiebuff[0] = '\0';
+
+	snprintf(buff, sizeof(buff),
+		"GET %s HTTP/1.%s\r\n"
+		"%sHost: %s\r\n"
+		"User-Agent: Mozilla/4.5 [en] (" PACKAGE "/" VERSION ")\r\n"
+		"Accept: */*\r\n"
+		"%s" "\r\n", path, http11?"1":"0", cookiebuff, host,
+		keepalive? "Connection: Keep-Alive\r\n":"Connection: close\r\n");
+
+	yahoo_send_http_request(id, host, port, buff, callback, data, ssl);
+}
+
+void yahoo_http_head(int id, const char *url, const char *cookies, int len,
+	char *payload, yahoo_get_fd_callback callback, void *data)
+{
+	char host[255];
+	int port = 80;
+	char path[255];
+	char buff[2048];
+	char cookiebuff[1024];
+	int ssl = 0;
+
+	if (!url_to_host_port_path(url, host, &port, path, &ssl))
 		return;
-	}
-
-	while((n=yahoo_tcp_readline(buff, sizeof(buff), fd)) > 0) {
-		LOG(("Read:%s:\n", buff));
-		if(!strcmp(buff, ""))
-			break;
-
-		if( !strncasecmp(buff, "Content-length:", 
-				strlen("Content-length:")) ) {
-			tmp = strrchr(buff, ' ');
-			if(tmp)
-				filesize = atol(tmp);
-		}
-
-		if( !strncasecmp(buff, "Content-disposition:", 
-				strlen("Content-disposition:")) ) {
-			tmp = strstr(buff, "name=");
-			if(tmp) {
-				tmp+=strlen("name=");
-				if(tmp[0] == '"') {
-					char *tmp2;
-					tmp++;
-					tmp2 = strchr(tmp, '"');
-					if(tmp2)
-						*tmp2 = '\0';
-				} else {
-					char *tmp2;
-					tmp2 = strchr(tmp, ';');
-					if(!tmp2)
-						tmp2 = strchr(tmp, '\r');
-					if(!tmp2)
-						tmp2 = strchr(tmp, '\n');
-					if(tmp2)
-						*tmp2 = '\0';
-				}
-
-				filename = strdup(tmp);
-			}
-		}
-	}
-
-	LOG(("n == %d\n", n));
-	LOG(("Calling callback, filename:%s, size: %ld\n", filename, filesize));
-	ud->callback(id, fd, error, filename, filesize, ud->user_data);
-	FREE(ud);
-	FREE(filename);
-}
-
-void yahoo_get_url_fd(int id, const char *url, const struct yahoo_data *yd,
-		yahoo_get_url_handle_callback callback, void *data)
-{
-	char buff[1024];
-	struct url_data *ud = y_new0(struct url_data, 1);
-	snprintf(buff, sizeof(buff), "Y=%s; T=%s", yd->cookie_y, yd->cookie_t);
-	ud->callback = callback;
-	ud->user_data = data;
-	yahoo_http_get(id, url, buff, yahoo_got_url_fd, ud);
-}
-
+
+	/* Allow cases when we don't need to send a cookie */
+	if (cookies)
+		snprintf(cookiebuff, sizeof(cookiebuff), "Cookie: %s\r\n",
+			cookies);
+	else
+		cookiebuff[0] = '\0';
+
+	snprintf(buff, sizeof(buff),
+		"HEAD %s HTTP/1.0\r\n"
+		"Accept: */*\r\n"
+		"Host: %s:%d\r\n"
+		"User-Agent: Mozilla/4.5 [en] (" PACKAGE "/" VERSION ")\r\n"
+		"%s"
+		"Content-Length: %d\r\n"
+		"Cache-Control: no-cache\r\n"
+		"\r\n%s", path, host, port, cookiebuff, len,
+		payload?payload:"");
+
+	yahoo_send_http_request(id, host, port, buff, callback, data, ssl);
+}
+
Index: protocols/yahoo/yahoo_httplib.h
===================================================================
--- protocols/yahoo/yahoo_httplib.h	(revision ee6cc946dc4ee82cb641df94a6ba101e99253af2)
+++ protocols/yahoo/yahoo_httplib.h	(revision 2528cdad90271f80d2ffe0e679ff8258f3e94e4c)
@@ -29,20 +29,20 @@
 #include "yahoo2_types.h"
 
-char *yahoo_urlencode(const char *instr);
-char *yahoo_urldecode(const char *instr);
-char *yahoo_xmldecode(const char *instr);
+	char *yahoo_urlencode(const char *instr);
+	char *yahoo_urldecode(const char *instr);
+	char *yahoo_xmldecode(const char *instr);
 
-int yahoo_tcp_readline(char *ptr, int maxlen, int fd);
-void yahoo_http_post(int id, const char *url, const char *cookies, long size,
-		yahoo_get_fd_callback callback, void *data);
-void yahoo_http_get(int id, const char *url, const char *cookies,
-		yahoo_get_fd_callback callback, void *data);
-void yahoo_get_url_fd(int id, const char *url, const struct yahoo_data *yd,
-		yahoo_get_url_handle_callback callback, void *data);
-
+	int yahoo_tcp_readline(char *ptr, int maxlen, void *fd);
+	void yahoo_http_post(int id, const char *url, const char *cookies,
+		long size, yahoo_get_fd_callback callback, void *data);
+	void yahoo_http_get(int id, const char *url, const char *cookies,
+		int http11, int keepalive, yahoo_get_fd_callback callback,
+		void *data);
+	void yahoo_http_head(int id, const char *url, const char *cookies,
+		int size, char *payload, yahoo_get_fd_callback callback,
+		void *data);
 
 #ifdef __cplusplus
 }
 #endif
-
 #endif
Index: protocols/yahoo/yahoo_list.h
===================================================================
--- protocols/yahoo/yahoo_list.h	(revision ee6cc946dc4ee82cb641df94a6ba101e99253af2)
+++ protocols/yahoo/yahoo_list.h	(revision 2528cdad90271f80d2ffe0e679ff8258f3e94e4c)
@@ -24,5 +24,5 @@
 #define __YLIST_H__
 
-/* GLib has linked list already, so I don't see why libyahoo2 has to copy this... */
+/* BitlBee already uses GLib so use it. */
 
 typedef GList YList;
